import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import '../../fx_utilities.dart';
import '../../fx_extensions.dart';

///Get custom button style
class FxButton extends StatelessWidget {
  FxButton({
    required this.text,
    required this.onPressed,
    this.leadingIcon,
    this.trailingIcon,
    this.padding,
    this.margin,
    this.radius,
    this.color,
    this.shadow,
    this.textColor,
    this.iconColor,
    this.outlineColor = FxColors.primary,
    this.shape = BtnShape.rounded,
    this.size = BtnSize.normal,
    this.type = BtnType.solid,
    this.isBlock = false,
  });

  factory FxButton.primary({
    required String text,
    required VoidCallback onPressed,
    IconData? leadingIcon,
    IconData? trailingIcon,
    EdgeInsetsGeometry? padding,
    EdgeInsetsGeometry? margin,
    BorderRadius? radius,
    Color? color = FxColors.primary,
    List<BoxShadow>? shadow,
    Color? textColor = Colors.white,
    Color? iconColor,
    Color outlineColor = FxColors.primary,
    BtnShape shape = BtnShape.rounded,
    BtnSize size = BtnSize.normal,
    BtnType type = BtnType.solid,
    bool isBlock = false,
  }) =>
      FxButton(
        text: text,
        onPressed: onPressed,
        leadingIcon: leadingIcon,
        trailingIcon: trailingIcon,
        padding: padding,
        margin: margin,
        radius: radius,
        color: color,
        shadow: shadow,
        textColor: textColor,
        iconColor: iconColor,
        outlineColor: outlineColor,
        shape: shape,
        size: size,
        type: type,
        isBlock: isBlock,
      );
  factory FxButton.success({
    required String text,
    required VoidCallback onPressed,
    IconData? leadingIcon,
    IconData? trailingIcon,
    EdgeInsetsGeometry? padding,
    EdgeInsetsGeometry? margin,
    BorderRadius? radius,
    Color? color = FxColors.success,
    List<BoxShadow>? shadow,
    Color? textColor = Colors.white,
    Color? iconColor,
    Color outlineColor = FxColors.success,
    BtnShape shape = BtnShape.rounded,
    BtnSize size = BtnSize.normal,
    BtnType type = BtnType.solid,
    bool isBlock = false,
  }) =>
      FxButton(
        text: text,
        onPressed: onPressed,
        leadingIcon: leadingIcon,
        trailingIcon: trailingIcon,
        padding: padding,
        margin: margin,
        radius: radius,
        color: color,
        shadow: shadow,
        textColor: textColor,
        iconColor: iconColor,
        outlineColor: outlineColor,
        shape: shape,
        size: size,
        type: type,
        isBlock: isBlock,
      );
  factory FxButton.warning({
    required String text,
    required VoidCallback onPressed,
    IconData? leadingIcon,
    IconData? trailingIcon,
    EdgeInsetsGeometry? padding,
    EdgeInsetsGeometry? margin,
    BorderRadius? radius,
    Color? color = FxColors.warning,
    List<BoxShadow>? shadow,
    Color? textColor = Colors.white,
    Color? iconColor,
    Color outlineColor = FxColors.warning,
    BtnShape shape = BtnShape.rounded,
    BtnSize size = BtnSize.normal,
    BtnType type = BtnType.solid,
    bool isBlock = false,
  }) =>
      FxButton(
        text: text,
        onPressed: onPressed,
        leadingIcon: leadingIcon,
        trailingIcon: trailingIcon,
        padding: padding,
        margin: margin,
        radius: radius,
        color: color,
        shadow: shadow,
        textColor: textColor,
        iconColor: iconColor,
        outlineColor: outlineColor,
        shape: shape,
        size: size,
        type: type,
        isBlock: isBlock,
      );
  factory FxButton.danger({
    required String text,
    required VoidCallback onPressed,
    IconData? leadingIcon,
    IconData? trailingIcon,
    EdgeInsetsGeometry? padding,
    EdgeInsetsGeometry? margin,
    BorderRadius? radius,
    Color? color = FxColors.danger,
    List<BoxShadow>? shadow,
    Color? textColor = Colors.white,
    Color? iconColor,
    Color outlineColor = FxColors.danger,
    BtnShape shape = BtnShape.rounded,
    BtnSize size = BtnSize.normal,
    BtnType type = BtnType.solid,
    bool isBlock = false,
  }) =>
      FxButton(
        text: text,
        onPressed: onPressed,
        leadingIcon: leadingIcon,
        trailingIcon: trailingIcon,
        padding: padding,
        margin: margin,
        radius: radius,
        color: color,
        shadow: shadow,
        textColor: textColor,
        iconColor: iconColor,
        outlineColor: outlineColor,
        shape: shape,
        size: size,
        type: type,
        isBlock: isBlock,
      );
  factory FxButton.info({
    required String text,
    required VoidCallback onPressed,
    IconData? leadingIcon,
    IconData? trailingIcon,
    EdgeInsetsGeometry? padding,
    EdgeInsetsGeometry? margin,
    BorderRadius? radius,
    Color? color = FxColors.info,
    List<BoxShadow>? shadow,
    Color? textColor = Colors.white,
    Color? iconColor,
    Color outlineColor = FxColors.info,
    BtnShape shape = BtnShape.rounded,
    BtnSize size = BtnSize.normal,
    BtnType type = BtnType.solid,
    bool isBlock = false,
  }) =>
      FxButton(
        text: text,
        onPressed: onPressed,
        leadingIcon: leadingIcon,
        trailingIcon: trailingIcon,
        padding: padding,
        margin: margin,
        radius: radius,
        color: color,
        shadow: shadow,
        textColor: textColor,
        iconColor: iconColor,
        outlineColor: outlineColor,
        shape: shape,
        size: size,
        type: type,
        isBlock: isBlock,
      );
  factory FxButton.dark({
    required String text,
    required VoidCallback onPressed,
    IconData? leadingIcon,
    IconData? trailingIcon,
    EdgeInsetsGeometry? padding,
    EdgeInsetsGeometry? margin,
    BorderRadius? radius,
    Color? color = FxColors.dark,
    List<BoxShadow>? shadow,
    Color? textColor = Colors.white,
    Color? iconColor,
    Color outlineColor = FxColors.dark,
    BtnShape shape = BtnShape.rounded,
    BtnSize size = BtnSize.normal,
    BtnType type = BtnType.solid,
    bool isBlock = false,
  }) =>
      FxButton(
        text: text,
        onPressed: onPressed,
        leadingIcon: leadingIcon,
        trailingIcon: trailingIcon,
        padding: padding,
        margin: margin,
        radius: radius,
        color: color,
        shadow: shadow,
        textColor: textColor,
        iconColor: iconColor,
        outlineColor: outlineColor,
        shape: shape,
        size: size,
        type: type,
        isBlock: isBlock,
      );
  factory FxButton.light({
    required String text,
    required VoidCallback onPressed,
    IconData? leadingIcon,
    IconData? trailingIcon,
    EdgeInsetsGeometry? padding,
    EdgeInsetsGeometry? margin,
    BorderRadius? radius,
    Color? color = FxColors.light,
    List<BoxShadow>? shadow,
    Color? textColor = FxColors.dark,
    Color? iconColor,
    Color outlineColor = Colors.transparent,
    BtnShape shape = BtnShape.rounded,
    BtnSize size = BtnSize.normal,
    BtnType type = BtnType.solid,
    bool isBlock = false,
  }) =>
      FxButton(
        text: text,
        onPressed: onPressed,
        leadingIcon: leadingIcon,
        trailingIcon: trailingIcon,
        padding: padding,
        margin: margin,
        radius: radius,
        color: color,
        shadow: shadow,
        textColor: textColor,
        iconColor: iconColor,
        outlineColor: outlineColor,
        shape: shape,
        size: size,
        type: type,
        isBlock: isBlock,
      );

  ///set text to button
  final String text;

  ///set leading icon to button
  final IconData? leadingIcon;

  ///set trailing icon to button
  final IconData? trailingIcon;

  ///set
  final VoidCallback onPressed;

  ///set padding to button
  final EdgeInsetsGeometry? padding;

  ///set margin to button
  final EdgeInsetsGeometry? margin;

  ///set border radius to button
  final BorderRadius? radius;

  ///set border color
  final Color outlineColor;

  ///set button color
  final Color? color;

  ///set text color
  final Color? textColor;

  ///set icon color
  final Color? iconColor;

  ///set shadow to button
  final List<BoxShadow>? shadow;

  ///set button shape (eg. pill, rounded)
  final BtnShape shape;

  ///set button size (eg. small, medium, large)
  final BtnSize size;

  ///set button type (eg. solid,outline)
  final BtnType type;

  ///set button width full
  final bool isBlock;

  @override
  Widget build(BuildContext context) {
    return InkWell(
      splashColor:
          type == BtnType.solid ? FxColors.dark : color!.withOpacity(.3),
      onTap: onPressed,
      child: Container(
        padding: padding ?? FxPadding.pxy(h: 16, v: 7),
        decoration: BoxDecoration(
          borderRadius: radius ?? getBtnShape(),
          color: type == BtnType.solid ? color : getBtnType(),
          boxShadow: shadow ?? FxShadow.none,
          border: getButtonBorder(),
        ),
        child: Row(
          mainAxisSize: isBlock ? MainAxisSize.max : MainAxisSize.min,
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: <Widget>[
            Icon(
              leadingIcon,
              color: type == BtnType.solid
                  ? getTextColor(iconColor ?? getBtnType())
                  : color,
              size: getBtnSize() * 15,
            ).hide(leadingIcon == null),
            text
                .toText()
                .textStyle(
                  style: TextStyle(
                    color: type == BtnType.solid
                        ? textColor ?? getTextColor(color ?? getBtnType())
                        : color,
                  ),
                )
                .medium
                .textStyle(textScaleFactor: getBtnSize())
                .px4
                .hide(text.isEmpty),
            Icon(
              trailingIcon,
              color: type == BtnType.solid
                  ? getTextColor(iconColor ?? getBtnType())
                  : color,
              size: getBtnSize() * 15,
            ).hide(trailingIcon == null),
          ],
        ),
      ),
    );
  }

  ///Get button shape (eg. pill,rounded,leaf)
  BorderRadius getBtnShape() {
    if (BtnShape.pill == shape) return FxRadius.radius30;
    if (BtnShape.rounded == shape) return FxRadius.radius5;
    if (BtnShape.rleft == shape) return FxRadius.left(30);
    if (BtnShape.rright == shape) return FxRadius.right(30);
    if (BtnShape.leaf == shape)
      return FxRadius.only(bottomLeft: 30, topRight: 30);
    return FxRadius.all(0);
  }

  ///Get button size (eg. small,medium,large)
  double getBtnSize() {
    if (BtnSize.tiny == size) return .7;
    if (BtnSize.small == size) return 1;
    if (BtnSize.medium == size) return 1.5;
    if (BtnSize.large == size) return 1.8;
    return 1.3;
  }

  ///Get text color according to backgound color brightness
  Color getTextColor(Color color) => color == Colors.transparent
      ? FxColors.blueGray700
      : color.computeLuminance() > 0.5
          ? FxColors.blueGray700
          : Colors.white;

  ///Get [Fxbutton] type (eg. solid,outline)
  Color getBtnType() {
    if (BtnType.outline == type ||
        BtnType.outline2x == type ||
        BtnType.transparent == type) return Colors.transparent;
    return FxColors.primary;
  }

  ///Get [FxButton] border
  Border getButtonBorder() {
    if (BtnType.outline == type)
      return Border.all(
          color: color ?? outlineColor, width: 2, style: BorderStyle.solid);
    if (BtnType.outline2x == type)
      return Border.all(
          color: color ?? outlineColor, width: 3, style: BorderStyle.solid);

    return Border.all(style: BorderStyle.none);
  }
}

enum BtnShape { pill, flat, rounded, leaf, rleft, rright }
enum BtnType { solid, outline, outline2x, transparent }
enum BtnSize { tiny, small, normal, medium, large }
