import 'package:customize/customize.dart';
import 'package:flutter/material.dart';

class FxTextFormField extends StatelessWidget {
  const FxTextFormField({
    required this.hintText,
    Key? key,
    this.fieldColor,
    this.leadingIcon,
    this.isSecure = false,
    this.borderRadius,
    this.maxLines,
    this.keyboardType,
    this.border = false,
  }) : super(key: key);

  final String hintText;
  final Color? fieldColor;
  final IconData? leadingIcon;
  final bool isSecure;
  final double? borderRadius;
  final int? maxLines;
  final TextInputType? keyboardType;
  final bool border;

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: FxPadding.px20,
      decoration: BoxDecoration(
        color: fieldColor ?? Colors.transparent,
        border: Border.all(
            color: FxColors.blueGray300,
            style: border ? BorderStyle.solid : BorderStyle.none),
        borderRadius: FxRadius.all(borderRadius ?? 10),
      ),
      child: Row(
        children: <Widget>[
          Expanded(
            child: TextFormField(
              decoration: InputDecoration(
                icon: Icon(leadingIcon).hide(leadingIcon == null),
                hintText: hintText,
                border: InputBorder.none,
              ),
              keyboardType: keyboardType,
              obscureText: isSecure,
              maxLines: maxLines ?? 1,
            ),
          ),
        ],
      ),
    );
  }
}
